<?php
/**********************************************************************
***********************************************************************/

$page_security = 'SA_GLANALYTIC';
$path_to_root="../..";

include($path_to_root . "/includes/db_pager.inc");
include_once($path_to_root . "/includes/session.inc");

include_once($path_to_root . "/includes/date_functions.inc");
include_once($path_to_root . "/includes/ui.inc");
$js = "";
if ($SysPrefs->use_popup_windows)
	$js .= get_js_open_window(800, 500);
if (user_use_date_picker())
	$js .= get_js_date_picker();

page(_($help_context = "Journal Inquiry"), false, false, "", $js);

//-----------------------------------------------------------------------------------
// Ajax updates
//
if (get_post('Search'))
{
	$Ajax->activate('journal_tbl');
}
//--------------------------------------------------------------------------------------
if (!isset($_POST['filterType']))
	$_POST['filterType'] = -1;

start_form();

start_table(TABLESTYLE_NOBORDER);
start_row();
    journal_types_list_cells(_("Type:"), "filterType");
    ref_cells(_("Trans. No:"), 'trans_no', '',null, _('Enter reference fragment or leave empty'));
    ref_cells(_("Reference:"), 'Ref', '',null, _('Enter reference fragment or leave empty'));
end_row();
start_row();
    date_cells(_("From:"), 'FromDate', '', null, 0, -1, 0);
    date_cells(_("To:"), 'ToDate');
    check_cells( _("Show closed:"), 'AlsoClosed', null);
end_row();
start_row();
    project_list_cells(_("Project:"), 'project_id', null, _('Select a project'), true);    
    $gl_tr_tp_array = array("'GL_TRANS_TYPE_BANKPAYMENT'", "'GL_TRANS_TYPE_BANKDEPOSIT'", "'GL_TRANS_TYPE_CASH_PAYMENT'", 
                            "'GL_TRANS_TYPE_CASH_RECEIPT'", "'GL_TRANS_TYPE_GL_CREDIT'", "'GL_TRANS_TYPE_GL_DEBIT'", "'GL_TRANS_TYPE_JOURNAL'");
    $list_codes_in = implode(',', $gl_tr_tp_array);
    filtered_value_list_cells('GL Trans Type:', 'gl_trans_type_id', $list_codes_in, '', null, '', true); 
    //        end_row();
//    ref_cells(_("Memo:"), 'Memo', '',null, _('Enter memo fragment or leave empty'));   

end_row();
start_row();
    $payment_person_all_types[-1] = '';
    ksort($payment_person_all_types);
    custom_values_list_cells('Person Type:', 'person_type_id', $payment_person_all_types, null, false, true);
    ref_cells(_("Memo:"), 'Memo', '',null, _('Enter memo fragment or leave empty'));    

    submit_cells('Search', _("Search"), '', '', 'default');
end_row();
end_table();

function journal_pos($row)
{
	return $row['gl_seq'] ? $row['gl_seq'] : '-';
}

function systype_name($dummy, $type)
{
	global $systypes_array;
	
	return $systypes_array[$type];
}

function view_link($row) 
{
	return get_trans_view_str($row["type"], $row["type_no"]);
}

function gl_link($row) 
{
	return get_gl_view_str($row["type"], $row["type_no"]);
}

function _person_type($row) {
    global $payment_person_all_types;
    
        return (key_exists($row['person_type_id'], $payment_person_all_types)) ? $payment_person_all_types[$row['person_type_id']] : '';
}
function _gl_trans_type($row) {
    return $row['gl_trans_type_name'];
}
function _project_code($row) {
    return $row['project_code'];
}


$editors = array(
	ST_JOURNAL => "/gl/gl_journal.php?ModifyGL=Yes&trans_no=%d&trans_type=%d",
	ST_BANKPAYMENT => "/gl/gl_bank.php?ModifyPayment=Yes&trans_no=%d&trans_type=%d",
	ST_BANKDEPOSIT => "/gl/gl_bank.php?ModifyDeposit=Yes&trans_no=%d&trans_type=%d",
//	4=> Funds Transfer,
   ST_SALESINVOICE => "/sales/customer_invoice.php?ModifyInvoice=%d",
//   11=>
// free hand (debtors_trans.order_==0)
//	"/sales/credit_note_entry.php?ModifyCredit=%d"
// credit invoice
//	"/sales/customer_credit_invoice.php?ModifyCredit=%d"
//	 12=> Customer Payment,
   ST_CUSTDELIVERY => "/sales/customer_delivery.php?ModifyDelivery=%d",
//   16=> Location Transfer,
//   17=> Inventory Adjustment,
//   20=> Supplier Invoice,
//   21=> Supplier Credit Note,
//   22=> Supplier Payment,
//   25=> Purchase Order Delivery,
//   28=> Work Order Issue,
//   29=> Work Order Production",
//   35=> Cost Update,

//    ST_POINTSUPDATE => "/sales/customer_invoice.php?ModifyInvoice=%d",
);

//function edit_link($row)
//{
//	global $editors;
//
//	$ok = true;
//	if ($row['type'] == ST_SALESINVOICE)
//	{
//		$myrow = get_customer_trans($row["type_no"], $row["type"]);
//		if ($myrow['alloc'] != 0 || get_voided_entry(ST_SALESINVOICE, $row["type_no"]) !== false)
//			$ok = false;
//	}		
//	return isset($editors[$row["type"]]) && !is_closed_trans($row["type"], $row["type_no"]) && $ok ? 
//		pager_link(_("Edit"), 
//			sprintf($editors[$row["type"]], $row["type_no"], $row["type"]),
//			ICON_EDIT) : '';
//}

//$sql = get_sql_for_journal_inquiry(get_post('filterType', -1), get_post('FromDate'),
//	get_post('ToDate'), get_post('Ref'), get_post('Memo'), check_value('AlsoClosed'), get_post('trans_no'));
$sql = get_sql_for_journal_inquiry(get_post('filterType', -1), get_post('FromDate'), get_post('ToDate'), get_post('Ref'), get_post('Memo'), 
                                   check_value('AlsoClosed'), get_post('trans_no'), $_POST['person_type_id'], $_POST['gl_trans_type_id'], $_POST['project_id']);

$cols = array(
	_("#") => array('fun'=>'journal_pos', 'align'=>'center'), 
	_("Date") =>array('name'=>'tran_date','type'=>'date','ord'=>'desc'),
	_("Type") => array('fun'=>'systype_name'), 
	_("Trans #") => array('fun'=>'view_link'), 
	_("Reference"), 
	_("Person Type") => array('fun'=>'_person_type'), 
	_("GL Trans Type") => array('fun'=>'_gl_trans_type'), 
	_("Project") => array('fun'=>'_project_code'), 
	_("Amount") => array('type'=>'amount'),
	_("Memo"),
	_("User"),
	_("View") => array('insert'=>true, 'fun'=>'gl_link')
    
	//array('insert'=>true, 'fun'=>'edit_link')
);

if (!check_value('AlsoClosed')) {
	$cols[_("#")] = 'skip';
}

$table =& new_db_pager('journal_tbl', $sql, $cols);

$table->width = "80%";

display_db_pager($table);

end_form();
end_page();

?>
